<?php

/******************************************************************************/
/******************************************************************************/

class ThemeMenu
{
	/**************************************************************************/

	function __construct()
	{
		
	}
	
	/**************************************************************************/
	
	function getMenuDictionary($useNone=true,$useGlobal=true,$useLeftUnchaged=false)
	{
		$menu=get_terms('nav_menu');
		
		$data=array();
		
		if($useNone) $data[0]=array(__('[None]',THEME_DOMAIN));
		if($useGlobal) $data[-1]=array(__('[Use global settings]',THEME_DOMAIN));
		if($useLeftUnchaged) $data[-10]=array(__('[Left unchanged]',THEME_DOMAIN));

		foreach($menu as $singlePost)
			$data[$singlePost->term_id]=array($singlePost->name);
		
		return($data);
	}
	
	/**************************************************************************/
	
	function create()
	{
		global $norgeParentPost;
		
		$attribute=array('menu_id'=>0);
		
		$locationId='menu_top';
		
		$menu=wp_get_nav_menus();
		$menuLocation=get_nav_menu_locations();

		if(isset($menuLocation[$locationId])) 
		{
			foreach($menu as $m)
			{
				if($m->term_id==$menuLocation[$locationId])
					$attribute['menu_id']=$m->term_id;
			}
		}

		if($attribute['menu_id']==0)
			if(ThemeOption::getGlobalOption($norgeParentPost->post,'menu_top')==0) return;
		if($attribute['menu_id']==0)
			$attribute['menu_id']=ThemeOption::getGlobalOption($norgeParentPost->post,'menu_top');
	
		$attribute['menu_responsive_mode']=ThemeOption::getOption('menu_responsive_mode');
		$attribute['menu_animation_enable']=ThemeOption::getOption('menu_animation_enable');
		$attribute['menu_animation_speed_open']=ThemeOption::getOption('menu_animation_speed_open');
		$attribute['menu_animation_speed_close']=ThemeOption::getOption('menu_animation_speed_close');
		$attribute['menu_animation_delay']=ThemeOption::getOption('menu_animation_delay');
		
		$html=null;

		$option=array();

		$key=array
		(
			'menu_responsive_mode',
			'menu_animation_enable',
			'menu_animation_speed_open',
			'menu_animation_speed_close',
			'menu_animation_delay'
		);

		foreach($key as $value)
			$option[$value]=$attribute[$value];

		$option['responsive_menu_id']=ThemeHelper::createId('theme_menu_responsive');
		$option['responsive_menu_label']=__('Menu');

		$id=ThemeHelper::createId('theme_menu');

		$classMenu=array('theme-menu-default');
		$classMenuResponsive=array('theme-menu-responsive');

		$class=array('theme-menu');

		$menuAttribute=array
		(
			'menu'				=>	$attribute['menu_id'],
			'walker'			=>	new ThemeMenuWalker(),
			'menu_class'		=>	'theme-clear-fix sf-menu',
			'container'			=>	'',
			'container_class'	=>	'',
			'echo'				=>	0
		);

		$menuResponsiveAttribute=array
		(
			'id'				=>	$option['responsive_menu_id'],
			'menu'				=>	$attribute['menu_id'],
			'walker'			=>	new ThemeMenuResponsiveWalker(),
			'menu_class'		=>	'theme-clear-fix',
			'container'			=>	'',
			'container_class'	=>	'',
			'echo'				=>	0,
			'items_wrap'		=>	'<div id="%1$s" class="%2$s"><div id="'.esc_attr($option['responsive_menu_id']).'"><ul>%3$s</ul></div></div>'
		);

		$html=
		'
			<div'.ThemeHelper::createClassAttribute($class).' id="'.esc_attr($id).'">
				<div'.ThemeHelper::createClassAttribute($classMenu).'>
					'.wp_nav_menu($menuAttribute).'
				</div>
				<div'.ThemeHelper::createClassAttribute($classMenuResponsive).'>
					'.wp_nav_menu($menuResponsiveAttribute).'
				</div>
			</div>
		';

		return($html);
	}
	
	/**************************************************************************/
}

/******************************************************************************/
/******************************************************************************/