<?php

/******************************************************************************/
/******************************************************************************/

class Theme
{
	/**************************************************************************/
	
	var $themeDefaultOption=array
	(
		'blog_category_post_id'													=>	'0',
		'blog_archive_post_id'													=>	'0',
		'blog_search_post_id'													=>	'0',
		'blog_author_post_id'													=>	'0',
		'blog_sort_field'														=>	'post_date',
		'blog_sort_direction'													=>	'desc',		
		'blog_automatic_excerpt_length'											=>	'35',
		'blog_post_related_automatic_excerpt_length'							=>	'17',
		'post_date_visible'														=>	'1',
		'post_tag_visible'														=>	'1',
		'post_category_visible'													=>	'1',
		'post_author_name_visible'												=>	'1',
		'post_author_info_visible'												=>	'1',
		'post_like_count_visible'												=>	'1',
		'post_view_count_visible'												=>	'1',
		'post_comment_count_visible'											=>	'1',
		'post_navigation_visible'												=>	'1',
		'post_share_button_visible'												=>	'1',
		'post_post_related_visible'												=>	'1',
		'page_404_page_id'														=>	'0',
		'logo_src'																=>	'',
		'menu_top'																=>	'0',
		'menu_animation_enable'													=>	'1',
		'menu_animation_speed_open'												=>	'400',
		'menu_animation_speed_close'											=>	'0',
		'menu_animation_delay'													=>	'0',
		'favicon_url'															=>	'',
		'header_enable'															=>	'1',
		'header_sticky_enable'													=>	'1',
		'header_sticky_hide_scroll_enable'										=>	'0',		
		'header_logo_enable'													=>	'1',
		'header_menu_enable'													=>	'1',
		'header_menu_display_at_start_enable'									=>	'0',
		'header_search_enable'													=>	'1',
		'header_responsive_mode'												=>	'768',
		'header_height'															=>	'80',
		'header_navigation_bar_open_event_duration'								=>	'300',
		'header_navigation_bar_open_event_easing'								=>	'easeOutExpo',
		'header_navigation_bar_close_event_duration'							=>	'600',
		'header_navigation_bar_close_event_easing'								=>	'easeOutExpo',		
		'header_navigation_bar_fade_event_duration'								=>	'600',
		'header_navigation_bar_fade_event_easing'								=>	'easeInOutBack',
		'content_header_enable'													=>	'1',
		'footer_enable'															=>	'1',
		'footer_sticky_enable'													=>	'1',
		'comment_automatic_excerpt_length'										=>	'25',
		'widget_area_sidebar'													=>	'',
		'widget_area_sidebar_location'											=>	'',
		'widget_area_footer'													=>	'',		
		'custom_js_code'														=>	'',
		'right_click_enable'													=>	'1',
		'copy_selection_enable'													=>	'1',
		'go_to_page_top_enable'													=>	'1',
		'go_to_page_top_hash'													=>	'up',
		'go_to_page_top_animation_enable'										=>	'1',
		'go_to_page_top_animation_duration'										=>	'500',
		'go_to_page_top_animation_easing'										=>	'easeInCubic',
		'responsive_mode_enable'												=>	'1',
		'fancybox_image_padding'												=>	'10',
		'fancybox_image_margin'													=>	'20',
		'fancybox_image_min_width'												=>	'100',
		'fancybox_image_min_height'												=>	'100',
		'fancybox_image_max_width'												=>	'9999',
		'fancybox_image_max_height'												=>	'9999',
		'fancybox_image_helper_button_enable'									=>	'1',
		'fancybox_image_autoresize'												=>	'1',
		'fancybox_image_autocenter'												=>	'1',
		'fancybox_image_fittoview'												=>	'1',
		'fancybox_image_arrow'													=>	'1',
		'fancybox_image_close_button'											=>	'1',
		'fancybox_image_close_click'											=>	'0',
		'fancybox_image_next_click'												=>	'0',
		'fancybox_image_mouse_wheel'											=>	'1',
		'fancybox_image_autoplay'												=>	'0',
		'fancybox_image_loop'													=>	'1',
		'fancybox_image_playspeed'												=>	'3000',
		'fancybox_image_animation_effect_open'									=>	'fade',
		'fancybox_image_animation_effect_close'									=>	'fade',
		'fancybox_image_animation_effect_next'									=>	'elastic',
		'fancybox_image_animation_effect_previous'								=>	'elastic',
		'fancybox_image_easing_open'											=>	'easeInQuad',
		'fancybox_image_easing_close'											=>	'easeInQuad',
		'fancybox_image_easing_next'											=>	'easeInQuad',
		'fancybox_image_easing_previous'										=>	'easeInQuad',
		'fancybox_image_speed_open'												=>	'250',
		'fancybox_image_speed_close'											=>	'250',
		'fancybox_image_speed_next'												=>	'250',
		'fancybox_image_speed_previous'											=>	'250',
		'maintenance_mode_enable'												=>	'0',
		'maintenance_mode_post_id'												=>	'0',
		'maintenance_mode_user_id'												=>	'0',
		'maintenance_mode_ip_address'											=>	'',
		'install'																=>	'1',	
	);	
	
	var $responsiveMode=array(1280,960,768,480);

	/**************************************************************************/
	/**************************************************************************/
	
	function __construct()
	{

	}
	
	/**************************************************************************/
	
	function prepareLibrary()
	{
		$this->libraryDefault=array
		(
			'script'															=>	array
			(
				'use'															=>	1,
				'inc'															=>	true,
				'path'															=>	THEME_URL_SCRIPT,
				'file'															=>	'',
				'in_footer'														=>	true,				
				'dependencies'													=>	array('jquery')
			),
			'style'																=>	array
			(
				'use'															=>	1,
				'inc'															=>	true,
				'path'															=>	THEME_URL_STYLE,
				'file'															=>	'',
				'dependencies'													=>	array()
			)			
		);
		
		$this->library=array
		(
			'script'															=>	array
			(
				'jquery'														=>	array
				(
					'use'														=>	3,
					'path'														=>	'',
					'in_footer'													=>	false
				),
				'jquery-ui-core'												=>	array
				(
					'path'														=>	''
				),
				'jquery-ui-button'												=>	array
				(
					'path'														=>	'',
					'dependencies'												=>	array('jquery','jquery-ui-core')
				),
				'jquery-ui-slider'												=>	array
				(
					'path'														=>	'',
					'dependencies'												=>	array('jquery','jquery-ui-core')
				),
				'jquery-ui-autocomplete'										=>	array
				(
					'path'														=>	'',
					'dependencies'												=>	array('jquery','jquery-ui-core')
				),
				'jquery-bbq'													=>	array
				(
					'use'														=>	3,
					'file'														=>	'jquery.ba-bbq.min.js'
				),
				'jquery-easing'													=>	array
				(
					'use'														=>	2,
					'file'														=>	'jquery.easing.js'
				),	
				'jquery-scrollTo'												=>	array
				(
					'use'														=>	2,
					'file'														=>	'jquery.scrollTo.min.js'
				),	
				'jquery-blockUI'												=>	array
				(
					'file'														=>	'jquery.blockUI.js'
				),
				'jquery-qtip'													=>	array
				(
					'file'														=>	'jquery.qtip.min.js'
				),
				'jquery-dropkick'												=>	array
				(
					'use'														=>	3,
					'file'														=>	'jquery.dropkick.min.js'
				),
				'jquery-colorpicker'											=>	array
				(
					'file'														=>	'jquery.colorpicker.js'
				),
				'jquery-infieldlabel'											=>	array
				(
					'use'														=>	3,
					'file'														=>	'jquery.infieldlabel.min.js'
				),
				'jquery-actual'													=>	array
				(
					'use'														=>	2,
					'file'														=>	'jquery.actual.min.js'
				),
				'jquery-responsiveElement'										=>	array
				(
					'use'														=>	2,
					'file'														=>	'jquery.responsiveElement.js'
				),
				'jquery-windowDimensionListener'								=>	array
				(
					'use'														=>	2,
					'file'														=>	'jquery.windowDimensionListener.js'
				),				
				'jquery-themeOption'											=>	array
				(
					'file'														=>	'jquery.themeOption.js'
				),
				'jquery-themeOptionElement'										=>	array
				(
					'file'														=>	'jquery.themeOptionElement.js'
				),
				'jquery-comment'												=>	array
				(
					'use'														=>	2,
					'file'														=>	'jquery.comment.js'
				),
				'superfish'														=>	array
				(
					'use'														=>	2,
					'file'														=>	'jquery.superfish.min.js'
				),
				'responsive-nav'												=>	array
				(
					'use'														=>	2,
					'file'														=>	'responsive-nav.min.js'
				),
				'jquery-header'													=>	array
				(
					'use'														=>	2,
					'file'														=>	'jquery.header.js'
				),
				'linkify'														=>	array
				(
					'use'														=>	2,
					'file'														=>	'linkify.js'
				),
				'jquery-cookie'													=>	array
				(
					'use'														=>	2,
					'file'														=>	'jquery.cookie.js'
				),			
				'jquery-waypoint'												=>	array
				(
					'use'														=>	2,
					'file'														=>	'jquery.waypoints.min.js'
				),
				'jquery-waypoint-sticky'										=>	array
				(
					'use'														=>	2,
					'file'														=>	'jquery.waypoints-sticky.min.js'
				),
				'public'														=>	array
				(
					'use'														=>	2,
					'file'														=>	'public.js'
				)	
			),
			'style'																=>	array
			(
				'jquery-ui'														=>	array
				(
					'file'														=>	'jquery.ui.min.css',
				),
				'google-font-open-sans'											=>	array
				(
					'path'														=>	'',
					'file'														=>	'//fonts.googleapis.com/css?family=Open+Sans:300italic,400italic,600italic,700italic,800italic,400,300,600,700,800',
				),
				'google-font-raleway'											=>	array
				(
					'use'														=>	2,
					'inc'														=>	false,
					'path'														=>	'',
					'file'														=>	'//fonts.googleapis.com/css?family=Raleway:100,200,300,regular,500,600,700,800,900&subset=latin',
				),	
				'google-font-crimson-text'										=>	array
				(
					'use'														=>	2,
					'inc'														=>	false,
					'path'														=>	'',
					'file'														=>	'//fonts.googleapis.com/css?family=Crimson+Text%3Aregular,italic,600,600italic,700,700italic&subset=latin',
				),	
				'jquery-dropkick'												=>	array
				(
					'use'														=>	3,
					'file'														=>	'jquery.dropkick.css',
				),
				'jquery-colorpicker'											=>	array
				(
					'file'														=>	'jquery.colorpicker.css',
				),	
				'jquery-qtip'													=>	array
				(
					'use'														=>	2,
					'file'														=>	'jquery.qtip.min.css',
				),
				'admin'															=>	array
				(
					'file'														=>	'admin.css',
				),
				'jquery-themeOption'											=>	array
				(
					'file'														=>	'jquery.themeOption.css',
				),
				'jquery-themeOption-overwrite'									=>	array
				(
					'file'														=>	'jquery.themeOption.overwrite.css',
				),	
				'widget'														=>	array
				(
					'use'														=>	2,
					'file'														=>	'widget.css',
				),
				'font-awesome'													=>	array
				(
					'use'														=>	2,
					'inc'														=>	false,
					'path'														=>	THEME_URL_LIBRARY,
					'file'														=>	'fontAwesome/css/font-awesome.min.css'
				),				
				'responsive-nav'												=>	array
				(
					'use'														=>	2,
					'file'														=>	'responsive-nav.css',
				),
				'tf-frontend'													=>	array
				(
					'use'														=>	2,
					'inc'														=>	false,
					'file'														=>	'TF.Frontend.css',
				),	
				'ts-frontend'													=>	array
				(
					'use'														=>	2,
					'inc'														=>	false,
					'file'														=>	'TS.Frontend.css',
				),	
				'pb-frontend'													=>	array
				(
					'use'														=>	2,
					'inc'														=>	false,
					'file'														=>	'PB.Frontend.css',
				),
				'pb-frontend-main'												=>	array
				(
					'use'														=>	2,
					'inc'														=>	false,
					'file'														=>	'PB.Frontend.main.css',
				),					
				'style'															=>	array
				(
					'use'														=>	2,
					'path'														=>	null,
					'file'														=>	get_stylesheet_uri(),
				),
				'responsive'													=>	array
				(
					'use'														=>	2,
					'inc'														=>	false,
					'file'														=>	'responsive.css',
				),
				'responsive-disable'											=>	array
				(
					'use'														=>	2,
					'inc'														=>	false,
					'file'														=>	'responsive-disable.css',
				),
				'style-custom'													=>	array
				(
					'use'														=>	2,
					'path'														=>	THEME_URL_MULTISITE_SITE_STYLE,
					'file'														=>	'style.css',
				)
			)
		);
		
		foreach($this->library as $libraryType=>$libraryTypeData)
		{
			$library=array_keys($libraryTypeData);
			
			foreach($library as $libraryName)
				$this->library[$libraryType][$libraryName]=array_merge($this->libraryDefault[$libraryType],$this->library[$libraryType][$libraryName]);
		}
	}
	
	/**************************************************************************/
	
	function addLibrary($type,$use)
	{
		foreach($this->library[$type] as $index=>$data)
		{
			if(!$data['inc']) continue;
			
			if($data['use']!=3)
			{
				if($data['use']!=$use) continue;
			}
			
			if($type=='script')
			{
				wp_enqueue_script($index,$data['path'].$data['file'],$data['dependencies'],false,$data['in_footer']);
			}
			else 
			{
				wp_enqueue_style($index,$data['path'].$data['file'],$data['dependencies'],false);
			}
		}
	}
	
	/**************************************************************************/
	
	function includeLibrary($test,$script=array(),$style=array())
	{
		if($test!=1) return;

		foreach((array)$script as $value)
		{
			if(array_key_exists($value,$this->library['script']))
				$this->library['script'][$value]['inc']=true;
		}
		foreach((array)$style as $value)
		{
			if(array_key_exists($value,$this->library['style']))
				$this->library['style'][$value]['inc']=true;	
		}
	}
	
	/**************************************************************************/

	function adminInit()
	{		
		$this->prepareLibrary();
		
		$this->addLibrary('style',1);
		$this->addLibrary('script',1);
	}
		
	/**************************************************************************/
	
	function adminPrintScript()
	{

	}
	
	/**************************************************************************/
	
	function adminMenuInit()
	{
		add_action('admin_print_scripts',array($this,'adminPrintScript'));
		add_theme_page(__('Theme Options',THEME_DOMAIN),__('Theme Options',THEME_DOMAIN),'edit_theme_options','ThemeOptions',array($this,'adminOptionPanelCreate'));
	}
	
	/**************************************************************************/
	
	function adminInitMetaBox()
	{
		$postType=get_post_types(array('public'=>true));
		foreach($postType as $data) 
		{
			if($data==='attachment') continue;
			add_meta_box('meta_box_general',__('General Options',THEME_DOMAIN),array($this,'adminCreateMetaBoxGeneral'),$data,'normal','low');
        }	
	}
	
	/**************************************************************************/
	
	function adminCreateMetaBoxGeneral()
	{
		global $post;
		
		$Menu=new ThemeMenu();
		$WidgetArea=new ThemeWidgetArea();
		
		$data=array();
	
		$data['option']=ThemeOption::getPostMeta($post);
		$data['nonce']=wp_nonce_field('adminSaveMetaBox',THEME_CONTEXT.'_meta_box_noncename',false,false);
		
		$data['dictionary']['widgetArea']=$WidgetArea->getWidgetAreaDictionary();
		$data['dictionary']['widgetAreaLocation']=$WidgetArea->getWidgetAreaLocationDictionary(false);
		
		$data['dictionary']['menu']=$Menu->getMenuDictionary(true,true,false);
		
		$data['dictionary']['postCategory']=ThemeHelper::createTermDictionary('category',array(),array(),array(),'id');

		$Template=new ThemeTemplate($data,THEME_PATH_TEMPLATE.'admin/meta_box_general.php');
		echo $Template->output();					
	}
	
	/**************************************************************************/
	
	function adminSaveMetaBox($postId)
	{
		if($_POST)
		{
			if(ThemeHelper::checkSavePost($postId,THEME_CONTEXT.'_meta_box_noncename','adminSaveMetaBox')===false) return(false);
			
			$option=ThemeHelper::getPostOption();
			
			update_post_meta($postId,THEME_OPTION_PREFIX,$option);
		}		
	}

	/**************************************************************************/
	
	function adminOptionPanelCreate()
	{
		wp_enqueue_media();
		
		$data=array();
		
		$CSS=new ThemeCSS();
		$Menu=new ThemeMenu();
		$Page=new ThemePage();
		$Blog=new ThemeBlog();
		$Easing=new ThemeEasing();
		$Fancybox=new ThemeFancybox();
		$WidgetArea=new ThemeWidgetArea();
		$Background=new ThemeBackground();
		
		$ResponsiveMode=new ThemeResponsiveMode($this->responsiveMode);
		
		$data['option']=ThemeOption::getOptionObject();
				
		$data['dictionary']['easingType']=$Easing->easingType;
		$data['dictionary']['fancyboxTransitionType']=$Fancybox->transitionType;
		
		$data['dictionary']['fontStyle']=$CSS->fontStyle;
		$data['dictionary']['fontWeight']=$CSS->fontWeight;
		
		$data['dictionary']['page']=$Page->getPageDictionary(false,false,false);
		
		$data['dictionary']['sortDirection']=$Blog->sortDirection;
		$data['dictionary']['sortPostBlogField']=$Blog->sortPostBlogField;

		$data['dictionary']['widgetArea-1']=$WidgetArea->getWidgetAreaDictionary(true,false,false);
		$data['dictionary']['widgetAreaLocation-1']=$WidgetArea->getWidgetAreaLocationDictionary(true,false,false);
		
		$data['dictionary']['widgetArea-2']=$WidgetArea->getWidgetAreaDictionary(true,true,true);
		$data['dictionary']['widgetAreaLocation-2']=$WidgetArea->getWidgetAreaLocationDictionary(true,true,true);
		
		$data['dictionary']['menu-1']=$Menu->getMenuDictionary(true,false,false);
		$data['dictionary']['menu-2']=$Menu->getMenuDictionary(true,true,true);
		
		$data['dictionary']['backgroundSize']=$Background->backgroundSize;
		$data['dictionary']['backgroundRepeat']=$Background->backgroundRepeat;
		
		$data['dictionary']['responsive']=$ResponsiveMode->getDictionary();
		$data['dictionary']['responsiveMedia']=$ResponsiveMode->getMedia();
		
		$data['dictionary']['user']=get_users();
		
		$Template=new ThemeTemplate($data,THEME_PATH_TEMPLATE.'admin/admin.php');
		echo $Template->output();			
	}
	
	/**************************************************************************/

	function setupTheme()
	{	
		global $content_width;
		if(!isset($content_width)) $content_width=1180;
		
		/***/
		
		$Post=new ThemePost();
		$Page=new ThemePage();
		$Image=new ThemeImage();
		$Comment=new ThemeComment();
		$WidgetArea=new ThemeWidgetArea();
		$MaintenanceMode=new ThemeMaintenanceMode();
		$WidgetPostRecent=new ThemeWidgetPostRecent();
		$WidgetPostMostLike=new ThemeWidgetPostMostLike();
		$WidgetPostMostComment=new ThemeWidgetPostMostComment();
		
		/***/
		
		$Image->register();
		$WidgetArea->register();
		
		$WidgetPostRecent->register();
		$WidgetPostMostLike->register();
		$WidgetPostMostComment->register();
		
		/***/
		
		add_theme_support('menus');
		add_theme_support('title-tag');
		add_theme_support('post-thumbnails'); 
		add_theme_support('automatic-feed-links');
		add_theme_support('post-formats',array('gallery','image','video','audio'));

		/***/
		
		if(function_exists('register_nav_menu')) register_nav_menu('menu_top','Menu Top');
		
		/***/
		
		add_filter('widget_text','do_shortcode');
		add_filter('wp_title',array($Page,'displayTitle'));	
		add_filter('image_size_names_choose',array($Image,'addImageSupport'));
		
		add_filter('excerpt_more',array($this,'filterExcerptMore'));
		add_filter('excerpt_length',array($this,'automaticExcerptLength'),999);
		
		add_filter('body_class',array($this,'filterBodyClass'));
		
		add_filter('user_contactmethods',array($this,'userContactMethods'));
		
		add_filter('the_password_form',array($this,'passwordForm'));
		
		/***/
		
		add_editor_style('editor-style.css');
		
		/***/

		add_action('save_post',array($this,'adminSaveMetaBox'));
		add_action('add_meta_boxes',array($Page,'adminInitMetaBox'));
		add_action('add_meta_boxes',array($Post,'adminInitMetaBox'));
		add_action('add_meta_boxes',array($this,'adminInitMetaBox'));

		add_action('wp_ajax_comment_add',array($Comment,'addComment'));
		add_action('wp_ajax_nopriv_comment_add',array($Comment,'addComment'));
		add_action('wp_ajax_comment_get',array($Comment,'getComment'));
		add_action('wp_ajax_nopriv_comment_get',array($Comment,'getComment'));

		add_action('wp_ajax_set_post_like_count',array($Post,'setPostLikeCount'));
		add_action('wp_ajax_nopriv_set_post_like_count',array($Post,'setPostLikeCount'));		
		
		add_action('tgmpa_register',array($this,'addPlugin'));
		
		add_action('admin_notices',array($this,'adminNotice'));
		
		add_action('init',array($MaintenanceMode,'init'));
		
		if(!function_exists('_wp_render_title_tag'))
			add_action('wp_head',array($this,'addTitleTag'));
		
		/***/

		load_theme_textdomain(THEME_DOMAIN,THEME_PATH.'languages/');

		/***/
		
		$install=(int)Themeoption::getOption('install');
		if($install==1) return;
		
		$option=$this->themeDefaultOption;
		
		$ResponsiveMode=new ThemeResponsiveMode($this->responsiveMode);
		
		$media=$ResponsiveMode->getMedia();
		foreach($media as $index=>$value)
			$option['custom_css_responsive_'.$index]='';
		
		$optionCurrent=ThemeOption::getOptionObject();
		
		$optionSave=array();
		foreach($option as $index=>$value)
		{
			if(!array_key_exists($index,$optionCurrent))
				$optionSave[$index]=$value;
		}
		
		$optionSave=array_merge((array)$optionSave,$optionCurrent);
		foreach($optionSave as $index=>$value)
		{
			if(!array_key_exists($index,$option))
				unset($optionSave[$index]);
		}

		$optionSave['install']=1;

		ThemeOption::resetOption();
		ThemeOption::updateOption($optionSave);
		
		$this->createCSSFile();
		
		/***/
		
		$argument=array
		(
			'post_type'							=>	array('post','page'),
			'post_status'						=>	'any',
			'posts_per_page'					=>	-1
		);
		
		$query=new WP_Query($argument);		
		if($query===false) return;

		foreach($query->posts as $value)
		{
			$meta=ThemeOption::getPostMeta($value);
			if(is_array($meta)) continue;		
			
			update_post_meta($value->ID,THEME_OPTION_PREFIX,$meta);
		}
	}
	
	/**************************************************************************/
	
	function switchTheme()
	{
		ThemeOption::updateOption(array('install'=>0));
	}
	
	/**************************************************************************/
	
	function adminOptionPanelSave()
	{
		$option=ThemeHelper::getPostOption();
		
		ThemeHelper::removeUIndex($option,'maintenance_mode_user_id');

		$response=array('global'=>array('error'=>1));
		
		$Blog=new ThemeBlog();
		$Notice=new ThemeNotice();
		$Easing=new ThemeEasing();
		$FancyBox=new ThemeFancybox();
		$Validation=new ThemeValidation($Notice);
		
		$invalidValue=esc_html__('Invalid value',THEME_DOMAIN);
		
		/* Blog */
		if(!in_array($option['blog_sort_field'],array_keys($Blog->sortPostBlogField)))
			$Notice->addError(ThemeHelper::getFormName('blog_sort_field',false),$invalidValue);		
		if(!in_array($option['blog_sort_direction'],array_keys($Blog->sortDirection)))
			$Notice->addError(ThemeHelper::getFormName('blog_sort_direction',false),$invalidValue);	
		$Validation->notice('isNumber',array($option['blog_automatic_excerpt_length'],0,999),array(ThemeHelper::getFormName('blog_automatic_excerpt_length',false),$invalidValue));
		$Validation->notice('isNumber',array($option['blog_post_related_automatic_excerpt_length'],0,999),array(ThemeHelper::getFormName('blog_post_related_automatic_excerpt_length',false),$invalidValue));
		
		/* Post */
		$Validation->notice('isNumber',array($option['post_date_visible'],0,1),array(ThemeHelper::getFormName('post_date_visible',false),$invalidValue));
		$Validation->notice('isNumber',array($option['post_tag_visible'],0,1),array(ThemeHelper::getFormName('post_tag_visible',false),$invalidValue));
		$Validation->notice('isNumber',array($option['post_category_visible'],0,1),array(ThemeHelper::getFormName('post_category_visible',false),$invalidValue));
		$Validation->notice('isNumber',array($option['post_author_name_visible'],0,1),array(ThemeHelper::getFormName('post_author_name_visible',false),$invalidValue));
		$Validation->notice('isNumber',array($option['post_author_info_visible'],0,1),array(ThemeHelper::getFormName('post_author_info_visible',false),$invalidValue));
		$Validation->notice('isNumber',array($option['post_like_count_visible'],0,1),array(ThemeHelper::getFormName('post_like_count_visible',false),$invalidValue));
		$Validation->notice('isNumber',array($option['post_view_count_visible'],0,1),array(ThemeHelper::getFormName('post_view_count_visible',false),$invalidValue));
		$Validation->notice('isNumber',array($option['post_comment_count_visible'],0,1),array(ThemeHelper::getFormName('post_comment_count_visible',false),$invalidValue));
		$Validation->notice('isNumber',array($option['post_navigation_visible'],0,1),array(ThemeHelper::getFormName('post_navigation_visible',false),$invalidValue));
		$Validation->notice('isNumber',array($option['post_share_button_visible'],0,1),array(ThemeHelper::getFormName('post_share_button_visible',false),$invalidValue));
		$Validation->notice('isNumber',array($option['post_post_related_visible'],0,1),array(ThemeHelper::getFormName('post_post_related_visible',false),$invalidValue));
		
		/* Page */
		
		/* Logo */
		
		/* Menu */
		$Validation->notice('isNumber',array($option['menu_animation_enable'],0,1),array(ThemeHelper::getFormName('menu_animation_enable',false),$invalidValue));
		$Validation->notice('isNumber',array($option['menu_animation_speed_open'],0,99999),array(ThemeHelper::getFormName('menu_animation_speed_open',false),$invalidValue));
		$Validation->notice('isNumber',array($option['menu_animation_speed_close'],0,99999),array(ThemeHelper::getFormName('menu_animation_speed_close',false),$invalidValue));
		$Validation->notice('isNumber',array($option['menu_animation_delay'],0,99999),array(ThemeHelper::getFormName('menu_animation_delay',false),$invalidValue));

		/* Favicon */
		
		/* Header */
		$Validation->notice('isNumber',array($option['header_enable'],0,1),array(ThemeHelper::getFormName('header_enable',false),$invalidValue));
		$Validation->notice('isNumber',array($option['header_sticky_enable'],0,1),array(ThemeHelper::getFormName('header_sticky_enable',false),$invalidValue));
		$Validation->notice('isNumber',array($option['header_sticky_hide_scroll_enable'],0,1),array(ThemeHelper::getFormName('header_sticky_hide_scroll_enable',false),$invalidValue));
		$Validation->notice('isNumber',array($option['header_logo_enable'],0,1),array(ThemeHelper::getFormName('header_logo_enable',false),$invalidValue));
		$Validation->notice('isNumber',array($option['header_menu_enable'],0,1),array(ThemeHelper::getFormName('header_menu_enable',false),$invalidValue));
		$Validation->notice('isNumber',array($option['header_menu_display_at_start_enable'],0,1),array(ThemeHelper::getFormName('header_menu_display_at_start_enable',false),$invalidValue));
		$Validation->notice('isNumber',array($option['header_search_enable'],0,1),array(ThemeHelper::getFormName('header_search_enable',false),$invalidValue));
		if(!in_array($option['header_responsive_mode'],$this->responsiveMode))
			$Notice->addError(ThemeHelper::getFormName('header_responsive_mode',false),$invalidValue);	
		$Validation->notice('isNumber',array($option['header_height'],0,999),array(ThemeHelper::getFormName('header_height',false),$invalidValue));
		$Validation->notice('isNumber',array($option['header_navigation_bar_open_event_duration'],0,99999),array(ThemeHelper::getFormName('header_navigation_bar_open_event_duration',false),$invalidValue));
		if(!in_array($option['header_navigation_bar_open_event_easing'],array_keys($Easing->easingType)))
			$Notice->addError(ThemeHelper::getFormName('header_navigation_bar_open_event_easing',false),$invalidValue);			
		$Validation->notice('isNumber',array($option['header_navigation_bar_close_event_duration'],0,99999),array(ThemeHelper::getFormName('header_navigation_bar_close_event_duration',false),$invalidValue));
		if(!in_array($option['header_navigation_bar_close_event_easing'],array_keys($Easing->easingType)))
			$Notice->addError(ThemeHelper::getFormName('header_navigation_bar_close_event_easing',false),$invalidValue);	
		$Validation->notice('isNumber',array($option['header_navigation_bar_fade_event_duration'],0,99999),array(ThemeHelper::getFormName('header_navigation_bar_fade_event_duration',false),$invalidValue));
		if(!in_array($option['header_navigation_bar_fade_event_easing'],array_keys($Easing->easingType)))
			$Notice->addError(ThemeHelper::getFormName('header_navigation_bar_fade_event_easing',false),$invalidValue);			

		/* Content */
		$Validation->notice('isNumber',array($option['content_header_enable'],0,1),array(ThemeHelper::getFormName('content_header_enable',false),$invalidValue));
		
		/* Footer */
		$Validation->notice('isNumber',array($option['footer_enable'],0,1),array(ThemeHelper::getFormName('footer_enable',false),$invalidValue));
		$Validation->notice('isNumber',array($option['footer_sticky_enable'],0,1),array(ThemeHelper::getFormName('footer_sticky_enable',false),$invalidValue));

		/* Comment */
		$Validation->notice('isNumber',array($option['comment_automatic_excerpt_length'],0,999),array(ThemeHelper::getFormName('comment_automatic_excerpt_length',false),$invalidValue));
	
		/* Widget area */
		$Validation->notice('isNumber',array($option['widget_area_sidebar_location'],0,2),array(ThemeHelper::getFormName('widget_area_sidebar_location',false),$invalidValue));
		
		/* Custom JS code */
		
		/* Content copying */
		$Validation->notice('isNumber',array($option['right_click_enable'],0,1),array(ThemeHelper::getFormName('right_click_enable',false),$invalidValue));
		$Validation->notice('isNumber',array($option['copy_selection_enable'],0,1),array(ThemeHelper::getFormName('copy_selection_enable',false),$invalidValue));
		
		/* Go to page to */
		$Validation->notice('isNumber',array($option['go_to_page_top_enable'],0,1),array(ThemeHelper::getFormName('go_to_page_top_enable',false),$invalidValue));
		$Validation->notice('isNotEmpty',array($option['go_to_page_top_hash']),array(ThemeHelper::getFormName('go_to_page_top_hash',false),$invalidValue));
		$Validation->notice('isNumber',array($option['go_to_page_top_animation_enable'],0,1),array(ThemeHelper::getFormName('go_to_page_top_animation_enable',false),$invalidValue));
		$Validation->notice('isNumber',array($option['go_to_page_top_animation_duration'],0,99999),array(ThemeHelper::getFormName('go_to_page_top_animation_duration',false),$invalidValue));
		if(!in_array($option['go_to_page_top_animation_easing'],array_keys($Easing->easingType)))
			$Notice->addError(ThemeHelper::getFormName('go_to_page_top_animation_easing',false),$invalidValue);			

		/* Responsive mode */
		$Validation->notice('isNumber',array($option['responsive_mode_enable'],0,1),array(ThemeHelper::getFormName('responsive_mode_enable',false),$invalidValue));
		
		/* Plugin / Fancybox for images */
		$Validation->notice('isNumber',array($option['fancybox_image_padding'],0,999),array(ThemeHelper::getFormName('fancybox_image_padding',false),$invalidValue));
		$Validation->notice('isNumber',array($option['fancybox_image_margin'],0,999),array(ThemeHelper::getFormName('fancybox_image_margin',false),$invalidValue));
		$Validation->notice('isNumber',array($option['fancybox_image_min_width'],1,9999),array(ThemeHelper::getFormName('fancybox_image_min_width',false),$invalidValue));
		$Validation->notice('isNumber',array($option['fancybox_image_min_height'],1,9999),array(ThemeHelper::getFormName('fancybox_image_min_height',false),$invalidValue));		
		$Validation->notice('isNumber',array($option['fancybox_image_max_width'],1,9999),array(ThemeHelper::getFormName('fancybox_image_max_width',false),$invalidValue));
		$Validation->notice('isNumber',array($option['fancybox_image_max_height'],1,9999),array(ThemeHelper::getFormName('fancybox_image_max_height',false),$invalidValue));
		$Validation->notice('isNumber',array($option['fancybox_image_helper_button_enable'],0,1),array(ThemeHelper::getFormName('fancybox_image_helper_button_enable',false),$invalidValue));
		$Validation->notice('isNumber',array($option['fancybox_image_autoresize'],0,1),array(ThemeHelper::getFormName('fancybox_image_autoresize',false),$invalidValue));
		$Validation->notice('isNumber',array($option['fancybox_image_autocenter'],0,1),array(ThemeHelper::getFormName('fancybox_image_autocenter',false),$invalidValue));
		$Validation->notice('isNumber',array($option['fancybox_image_fittoview'],0,1),array(ThemeHelper::getFormName('fancybox_image_fittoview',false),$invalidValue));
		$Validation->notice('isNumber',array($option['fancybox_image_arrow'],0,1),array(ThemeHelper::getFormName('fancybox_image_arrow',false),$invalidValue));
		$Validation->notice('isNumber',array($option['fancybox_image_close_button'],0,1),array(ThemeHelper::getFormName('fancybox_image_close_button',false),$invalidValue));
		$Validation->notice('isNumber',array($option['fancybox_image_close_click'],0,1),array(ThemeHelper::getFormName('fancybox_image_close_click',false),$invalidValue));
		$Validation->notice('isNumber',array($option['fancybox_image_next_click'],0,1),array(ThemeHelper::getFormName('fancybox_image_next_click',false),$invalidValue));
		$Validation->notice('isNumber',array($option['fancybox_image_mouse_wheel'],0,1),array(ThemeHelper::getFormName('fancybox_image_mouse_wheel',false),$invalidValue));
		$Validation->notice('isNumber',array($option['fancybox_image_autoplay'],0,1),array(ThemeHelper::getFormName('fancybox_image_autoplay',false),$invalidValue));
		$Validation->notice('isNumber',array($option['fancybox_image_loop'],0,1),array(ThemeHelper::getFormName('fancybox_image_loop',false),$invalidValue));
		$Validation->notice('isNumber',array($option['fancybox_image_playspeed'],1,99999),array(ThemeHelper::getFormName('fancybox_image_playspeed',false),$invalidValue));
		if(!in_array($option['fancybox_image_animation_effect_open'],array_keys($FancyBox->transitionType)))
			$Notice->addError(ThemeHelper::getFormName('fancybox_image_animation_effect_open',false),$invalidValue);	
		if(!in_array($option['fancybox_image_animation_effect_close'],array_keys($FancyBox->transitionType)))
			$Notice->addError(ThemeHelper::getFormName('fancybox_image_animation_effect_close',false),$invalidValue);	
		if(!in_array($option['fancybox_image_animation_effect_next'],array_keys($FancyBox->transitionType)))
			$Notice->addError(ThemeHelper::getFormName('fancybox_image_animation_effect_next',false),$invalidValue);	
		if(!in_array($option['fancybox_image_animation_effect_previous'],array_keys($FancyBox->transitionType)))
			$Notice->addError(ThemeHelper::getFormName('fancybox_image_animation_effect_previous',false),$invalidValue);	
		if(!in_array($option['fancybox_image_easing_open'],array_keys($Easing->easingType)))
			$Notice->addError(ThemeHelper::getFormName('fancybox_image_easing_open',false),$invalidValue);	
		if(!in_array($option['fancybox_image_easing_close'],array_keys($Easing->easingType)))
			$Notice->addError(ThemeHelper::getFormName('fancybox_image_easing_close',false),$invalidValue);	
		if(!in_array($option['fancybox_image_easing_next'],array_keys($Easing->easingType)))
			$Notice->addError(ThemeHelper::getFormName('fancybox_image_easing_next',false),$invalidValue);	
		if(!in_array($option['fancybox_image_easing_previous'],array_keys($Easing->easingType)))
			$Notice->addError(ThemeHelper::getFormName('fancybox_image_easing_previous',false),$invalidValue);	
		$Validation->notice('isNumber',array($option['fancybox_image_speed_open'],1,99999),array(ThemeHelper::getFormName('fancybox_image_speed_open',false),$invalidValue));
		$Validation->notice('isNumber',array($option['fancybox_image_speed_close'],1,99999),array(ThemeHelper::getFormName('fancybox_image_speed_close',false),$invalidValue));
		$Validation->notice('isNumber',array($option['fancybox_image_speed_next'],1,99999),array(ThemeHelper::getFormName('fancybox_image_speed_next',false),$invalidValue));
		$Validation->notice('isNumber',array($option['fancybox_image_speed_previous'],1,99999),array(ThemeHelper::getFormName('fancybox_image_speed_previous',false),$invalidValue));

		/* Plugin / Maintenance mode */
		$Validation->notice('isNumber',array($option['maintenance_mode_enable'],0,1),array(ThemeHelper::getFormName('maintenance_mode_enable',false),$invalidValue));
		
		if($Notice->isError())
		{
			$response['local']=$Notice->getError();
		}
		else
		{
			$response['global']['error']=0;
			ThemeOption::updateOption($option);
			
			$this->createCSSFile();
		}

		$response['global']['notice']=$Notice->createHTML(THEME_PATH_TEMPLATE.'notice.php');

		echo json_encode($response);
		exit;
	}
	
	/**************************************************************************/
	
	function publicInit()
	{
		require_once(ABSPATH.'wp-admin/includes/plugin.php');
		
		$this->prepareLibrary();
		
		$this->includeLibrary(ThemeOption::getOption('responsive_mode_enable'),null,array('responsive'));
		$this->includeLibrary(!ThemeOption::getOption('responsive_mode_enable'),null,array('responsive-disable'));

		if (is_singular()) wp_enqueue_script('comment-reply');
		
		$this->includeLibrary(!class_exists('TSThemeStyle'),null,array('ts-frontend'));
		$this->includeLibrary(!class_exists('PBPageBuilder'),null,array('pb-frontend','pb-frontend-main','font-awesome'));
		$this->includeLibrary(!class_exists('TFThemeFont'),null,array('tf-frontend','google-font-raleway','google-crimson-text'));
		
		$this->addLibrary('style',2);
		$this->addLibrary('script',2);
		
		$aPattern=array
		(
			'rightClick'			=>	'/^right_click_/',
			'selection'				=>	'/^copy_selection_/',
			'fancyboxImage'			=>	'/^fancybox_image_/',
			'goToPageTop'			=>	'/^go_to_page_top_/',
			'header'				=>	'/^header_/',
			'menu'					=>	'/^menu_/',
		);
		
		$option=ThemeOption::getOptionObject();
		
		foreach($aPattern as $indexPattern=>$valuePattern)
		{
			foreach($option as $index=>$value)
			{
				if(preg_match($valuePattern,$index,$result))
				{
					$nIndex=preg_replace($valuePattern,'',$index);
					$data[$indexPattern][$nIndex]=$value;
				}
			}
		}
		
		$data['config']['theme_url']=THEME_URL;
		$data['config']['ajax_url']=admin_url('admin-ajax.php');
		
		$data['menu']['responsive_menu_label']=esc_html__('Menu',THEME_DOMAIN);
		
		$param=array
		(
			'l10n_print_after'=>'themeOption='.json_encode($data).';'
		);
			
		wp_localize_script('public','themeOption',$param);
	}
		
	/**************************************************************************/

	function addPlugin()
	{
		$plugin=array
		(
			array
			(
				'name'                              =>	'Classic Editor',
				'slug'                              =>	'classic-editor',
				'required'                          =>	true,
				'force_activation'					=>	true,
				'force_deactivation'				=>	true
			),
			array
			(
				'name'								=>	'Page Builder',
				'slug'								=>	'page-builder',
				'source'							=>	THEME_PATH_SOURCE.'page-builder.zip',
				'required'							=>	true,
				'version'							=>	'3.0',
				'force_activation'					=>	true,
				'force_deactivation'				=>	true
			),
			array
			(
				'name'								=>	'Theme Styles',
				'slug'								=>	'theme-style',
				'source'							=>	THEME_PATH_SOURCE.'theme-style.zip',
				'required'							=>	true,
				'version'							=>	'4.6',
				'force_activation'					=>	true,
				'force_deactivation'				=>	true
			),
			array
			(
				'name'								=>	'Theme Demo Data Installer',
				'slug'								=>	'theme-demo-data-installer',
				'source'							=>	THEME_PATH_SOURCE.'theme-demo-data-installer.zip',
				'required'							=>	false,
				'version'							=>	'4.6',
				'force_activation'					=>	false,
				'force_deactivation'				=>	true
			),
			array
			(
				'name'								=>	'Theme Fonts',
				'slug'								=>	'theme-font',
				'source'							=>	THEME_PATH_SOURCE.'theme-font.zip',
				'required'							=>	true,
				'version'							=>	'2.9',
				'force_activation'					=>	true,
				'force_deactivation'				=>	true
			),
			array
			(
				'name'								=>	'Widget Area',
				'slug'								=>	'widget-area',
				'source'							=>	THEME_PATH_SOURCE.'widget-area.zip',
				'required'							=>	false,
				'version'							=>	'2.9',
				'force_activation'					=>	false,
				'force_deactivation'				=>	true
			),
			array
			(
				'name'								=>	'Better WordPress Minify',
				'slug'								=>	'bwp-minify',
				'source'							=>	THEME_PATH_SOURCE.'bwp-minify.zip',
				'required'							=>	false,
				'version'							=>	'1.3.3',
				'force_activation'					=>	false,
				'force_deactivation'				=>	true
			),
			array
			(
				'name'                              =>	'Classic Widgets',
				'slug'                              =>	'classic-widgets',
				'required'                          =>	false,
				'force_activation'					=>	false,
				'force_deactivation'				=>	false
			),
		);
	
		$config=array
		(
			'default_path'							=>	'',                      
			'menu'									=>	'tgmpa-install-plugins', 
			'has_notices'							=>	true,
			'dismissable'							=>	true,
			'dismiss_msg'							=>	'',
			'is_automatic'							=>	true,
			'message'								=>	'', 
			'strings'								=>	array
			(
				'page_title'						=>	__('Install Required Plugins','tgmpa'),
				'menu_title'						=>	__('Install Plugins','tgmpa'),
				'installing'						=>	__('Installing Plugin: %s','tgmpa'),
				'oops'								=>	__('Something went wrong with the plugin API.','tgmpa'),
				'notice_can_install_required'		=>	_n_noop('This theme requires the following plugin: %1$s.','This theme requires the following plugins: %1$s.','tgmpa'),
				'notice_can_install_recommended'	=>	_n_noop('This theme recommends the following plugin: %1$s.','This theme recommends the following plugins: %1$s.', 'tgmpa' ),
				'notice_cannot_install'				=>	_n_noop('Sorry, but you do not have the correct permissions to install the %s plugin. Contact the administrator of this site for help on getting the plugin installed.', 'Sorry, but you do not have the correct permissions to install the %s plugins. Contact the administrator of this site for help on getting the plugins installed.','tgmpa'),
				'notice_can_activate_required'		=>	_n_noop('The following required plugin is currently inactive: %1$s.','The following required plugins are currently inactive: %1$s.', 'tgmpa' ),
				'notice_can_activate_recommended'	=>	_n_noop('The following recommended plugin is currently inactive: %1$s.','The following recommended plugins are currently inactive: %1$s.', 'tgmpa' ),
				'notice_cannot_activate'			=>	_n_noop('Sorry, but you do not have the correct permissions to activate the %s plugin. Contact the administrator of this site for help on getting the plugin activated.', 'Sorry, but you do not have the correct permissions to activate the %s plugins. Contact the administrator of this site for help on getting the plugins activated.','tgmpa'),
				'notice_ask_to_update'				=>	_n_noop('The following plugin needs to be updated to its latest version to ensure maximum compatibility with this theme: %1$s.', 'The following plugins need to be updated to their latest version to ensure maximum compatibility with this theme: %1$s.', 'tgmpa' ),
				'notice_cannot_update'				=>	_n_noop('Sorry, but you do not have the correct permissions to update the %s plugin. Contact the administrator of this site for help on getting the plugin updated.', 'Sorry, but you do not have the correct permissions to update the %s plugins. Contact the administrator of this site for help on getting the plugins updated.','tgmpa'),
				'install_link'						=>	_n_noop('Begin installing plugin','Begin installing plugins','tgmpa'),
				'activate_link'						=>	_n_noop('Begin activating plugin','Begin activating plugins','tgmpa'),
				'return'							=>	__('Return to Required Plugins Installer','tgmpa'),
				'plugin_activated'					=>	__('Plugin activated successfully.','tgmpa' ),
				'complete'							=>	__('All plugins installed and activated successfully. %s','tgmpa'),
				'nag_type'							=>	'updated'
			)
		);

		tgmpa($plugin,$config);
	}
	
	/**************************************************************************/
	
	function createCSSFile()
	{
		if($this->createMultisitePath()===false) return;
		
		$content=null;
		
		$CSS=new ThemeCSS();
		$Validation=new ThemeValidation();
		$ResponsiveMode=new ThemeResponsiveMode($this->responsiveMode);
		
		ThemeOption::refreshOption();

		$media=$ResponsiveMode->getMedia();

		if(ThemeOption::getOption('responsive_mode_enable')!=1) $media=$media[1];
		
		$content.=$CSS->create(array
		(
			'selector'	=>	array
			(
				'.theme-header .theme-header-logo',
				'.theme-header .theme-header-logo>a',
				'.theme-header .theme-header-logo>a>img',
			),
			'property'	=>	array
			(
				'height'	=>	ThemeOption::getOption('header_height')
			)
		));	
		
		$content.=$CSS->create(array
		(
			'selector'	=>	array
			(
				'.theme-header .theme-header-search-button',
				'.theme-header .theme-header-menu-button'
			),
			'property'	=>	array
			(
				'line-height'	=>	ThemeOption::getOption('header_height').'px'
			)
		));
		
		foreach($media as $index=>$value)
		{
			if($Validation->isNotEmpty(ThemeOption::getOption('custom_css_responsive_'.$index)))
			{
				if((array_key_exists('min-width',$value)) && (array_key_exists('max-width',$value)))
				{
					$content.=
					'
					@media only screen  and (min-width:'.$value['min-width'].'px) and (max-width:'.$value['max-width'].'px)
					{
					'.ThemeOption::getOption('custom_css_responsive_'.$index).'
					}
					';
				}
				else
				{
					$content.=ThemeOption::getOption('custom_css_responsive_'.$index);
				}
			}
		}
		
		$file=THEME_PATH_MULTISITE_SITE_STYLE.'style.css';
		
		$ThemeWPFileSystem=new ThemeWPFileSystem();
		if($ThemeWPFileSystem->put_contents($file,$content,0755)===false) return(false);

		return(true);		
	}
		
	/**************************************************************************/
	
	function createMultisitePath()
	{
		$data=array
		(
			THEME_PATH_MULTISITE_SITE,
			THEME_PATH_MULTISITE_SITE_STYLE
		);
		
		foreach($data as $path)
		{
			if(!ThemeFile::dirExist($path)) @mkdir($path);			
			if(!ThemeFile::dirExist($path)) return(false);
		}
		
		return(true);
	}
	
	/**************************************************************************/
	
	function adminNotice()
	{
		$file=array(THEME_PATH_MULTISITE_SITE_STYLE.'style.css');
		foreach($file as $path)
		{
			if(!is_writable($path))
			{
				echo 
				'
					<div class="error">
						<p>'.sprintf(__('<b>File %s cannot be created. Please make sure that this location is writable.</b>',THEME_DOMAIN),str_replace('\\','/',$path)).'</p>
					</div>				
				';				
			}
		}
	}
	
	/**************************************************************************/
	
	function userContactMethods($contactmethods)
	{
		$social=array
		(
			'twitter'		=>	'Twitter',
			'facebook'		=>	'Facebook',
			'googleplus'	=>	'Google+'
		);
		
		foreach($social as $socialIndex=>$socialData)
		{
			if(!isset($contactmethods[$socialIndex]))
				$contactmethods[$socialIndex]=$socialData;
		}
 
		return ($contactmethods);
	}
	
	/**************************************************************************/
	
	function setPostMetaDefault(&$meta,$part='all')
	{
		if(in_array($part,array('general','all')))
		{
			ThemeHelper::setDefaultOption($meta,'menu_top',-1);
			ThemeHelper::setDefaultOption($meta,'widget_area_sidebar',-1);
			ThemeHelper::setDefaultOption($meta,'widget_area_sidebar_location',-1);
			ThemeHelper::setDefaultOption($meta,'widget_area_footer',-1);	
			ThemeHelper::setDefaultOption($meta,'content_header_enable',-1);
			ThemeHelper::setDefaultOption($meta,'footer_sticky_enable',-1);
		}
	}
	
	/**************************************************************************/
	
	function filterBodyClass($bodyClass)
	{
		$Validation=new ThemeValidation();
		
		$class=$this->getFooterStickyClass();
		if($Validation->isNotEmpty($class))
			array_push($bodyClass,$class);
		
		return($bodyClass);
	}
	
	/**************************************************************************/
	
	function filterExcerptMore()
	{
		$Theme=new Theme();
		$length=$Theme->automaticExcerptLength();
		
		if($length>0) return('<span class="theme-excerpt-more"> [...] <a href="'.esc_url(get_the_permalink()).'" title="'.the_title_attribute(array('echo'=>false)).'">'.__('Read More',THEME_DOMAIN).'</a></span>');

		return('');
	}
	
	/**************************************************************************/
	
	function getFooterStickyClass()
	{
		$mobileDetect=new Mobile_Detect();
		
		if($mobileDetect->isMobile()) return(null);

		global $norgeParentPost;

		if(ThemeOption::getGlobalOption($norgeParentPost->post,'footer_sticky_enable')==1) return('theme-footer-sticky');
		
		return(null);
	}
		
	/**************************************************************************/	
	
	function automaticExcerptLength()
	{
		global $post,$norge_functionCreatePostReleated;
		
		$length=55;
		
		if($norge_functionCreatePostReleated==1)
		{
			$length=ThemeOption::getOption('blog_post_related_automatic_excerpt_length');
		}
		else
		{
			switch($post->post_type)
			{
				case 'post':
					$length=ThemeOption::getOption('blog_automatic_excerpt_length');
				break;
			}
		}

		return($length);
	}
	
	/**************************************************************************/
	
	function passwordForm()
	{
		$html=
		'
			<form method="post" class="post-password-form" action="'.wp_login_url().'?action=postpass">
				<div>'.esc_html__('This content is password protected. To view it please enter your password below:',THEME_DOMAIN).'</div>
				<div><label for="pwbox-160" class="theme-infield-label">'.esc_html__('Password:',THEME_DOMAIN).'</label><input type="password" size="20" id="pwbox-160" name="post_password"></div>
				<div><input type="submit" name="Submit" value="'.esc_attr__('Submit',THEME_DOMAIN).'"></div>
			</form>
		';
		
		return($html);
	}
	
	/**************************************************************************/
	
	function addTitleTag() 
    {
		echo '<title>'.wp_title('|',false,'right').'</title>'."\n";
    }
	
	/**************************************************************************/
}

/******************************************************************************/
/******************************************************************************/