/******************************************************************************/
/******************************************************************************/

;(function($,doc,win) 
{
	"use strict";
	
	var Header=function(object,themeOption)
	{
		/**********************************************************************/
		
		var $self=this;
		var $themeOption=themeOption;

		var $header;
		var $navigation;
		
		var $menu;
		var $menuDefault;
		var $menuResponsive;
		
		var $menuResponsiveObject;
		
		var $menuBar;
		var $searchBar;

		/**********************************************************************/

		this.build=function() 
		{
			$header=$('.theme-header');
			$navigation=$('.theme-header-navigation');
			
			$menu=$('.theme-header .theme-menu');
			$menuDefault=$('.theme-header .theme-menu-default');
			$menuResponsive=$('.theme-header .theme-menu-responsive');
			
			$menuBar=$('.theme-header .theme-header-menu-bar');
			$searchBar=$('.theme-header .theme-header-search-bar');
			
			if($header.length!==1) return;
			
			/***/
			
			if($menu.length===1)
			{
				if($menuDefault.length===1)
				{
					if(parseInt($themeOption.menu.animation_enable)===0)
					{
						$themeOption.menu.animation_delay=0;
						$themeOption.menu.animation_speed_open=0;
						$themeOption.menu.animation_speed_close=0;
					}

					$menuDefault.children('ul:first').superfish(
					{ 
						delay		:	parseInt($themeOption.menu.animation_delay), 
						speed		:	parseInt($themeOption.menu.animation_speed_open), 
						speedOut	:	parseInt($themeOption.menu.animation_speed_close),	
						cssArrows	:	false,
						onInit		:	function()
						{
							$(this).find('ul .sf-with-ul').append('<i class="fa fa-angle-right"></i>');
						}
					}); 			
				}
				
				/***/

				if($menuResponsive.length===1)
				{
					$menuResponsiveObject=responsiveNav('.theme-header .theme-menu-responsive ul',{label:'',animate:false,insert:'before','init':function() 
					{

					}});
				}
			}
			
			/***/
			
			$self.setHeaderResponsive();
			$(window).windowDimensionListener({change:function(width,height)  
			{
				if(width || height)
				{
					$self.setHeaderResponsive();
				}
			}});
			
			/***/
			
			if(parseInt($themeOption.header.sticky_enable)===1)
			{
				$header.waypoint('sticky',
				{
					offset		:	parseInt($('#wpadminbar').length,10)===1 ?  $('#wpadminbar').actual('height') : 0,
					wrapper		:	'<div>',
					stuckClass	:	'theme-header-sticky',
					handler		:	function()
					{
	
					}
				});
				
				$header.parent('div').addClass('theme-header-parent');
				
				if(parseInt($themeOption.header.sticky_hide_scroll_enable)===1)
				{
					$(window).scroll(function() 
					{
						var height=$header.actual('outerHeight',{'includeMargin':true});

						if($header.hasClass('theme-header-sticky'))
						{
							$header.stop().animate({'opacity':0,'margin-top':-1*height},{duration:250,complete:function() {}});

							window.clearTimeout($.data(this,'scrollTimer'));
							$.data(this,'scrollTimer',setTimeout(function() 
							{
								$header.stop().animate({'opacity':1,'margin-top':0},{duration:100,complete:function() {}});
							},100));
						}
						else
						{
							$header.css({'opacity':1,'margin-top':0});
						}
					});
				}
			}
			
			/***/
			
			var clickEventType=((document.ontouchstart!==null) ? 'click' : 'touchstart');
		   
			$('.theme-header-search-button>a,.theme-header-menu-button>a').bind(clickEventType,function(e)
			{
				e.preventDefault();
				
				if($self.isNavigationProcessing()) return;
				$navigation.addClass('theme-status-processing');
			   
				var object=[$searchBar,$menuBar];
			   
				if($(this).parent('.theme-header-search-button').length!==1) object=[$menuBar,$searchBar];
				
				if($self.isNavigationOpen())
				{
					if($self.isObjectOpen(object[0]))
					{
						$self.closeNavigation();
					}
					else
					{
						$self.openObject(object);
						$self.closeObject(object);
						
						$self.setNavigationHeight(object);
					}
				}
				else
				{
					$self.openNavigation(object);
				}
			});
		   
			/***/

			$header.css({display:'block'});
		};
		
		/**********************************************************************/
		
		this.setNavigationStatus=function()
		{
			var cookieName='nr_theme_header_navigation_status';
			
			if($('.theme-header .theme-header-menu-bar').hasClass('theme-status-open'))
				$.cookie(cookieName,'menu',{path:'/'});
			else if($('.theme-header .theme-header-search-bar').hasClass('theme-status-open'))
				$.cookie(cookieName,'search',{path:'/'});
			else $.removeCookie(cookieName,{path:'/'}); 
		};
		
		/**********************************************************************/
		
		this.isNavigationOpen=function()
		{
			return($navigation.hasClass('theme-status-open') ? true : false);
		};
		
		/**********************************************************************/
		
		this.isNavigationProcessing=function()
		{
			return($navigation.hasClass('theme-status-processing') ? true : false);
		};
		
		/**********************************************************************/
		
		this.closeNavigation=function()
		{
			$navigation.animate({height:0},{duration:parseInt(themeOption.header.navigation_bar_close_event_duration),easing:themeOption.header.navigation_bar_close_event_easing,complete:function()
			{
				$navigation.removeClass('theme-status-processing theme-status-open');
				$navigation.find('*').removeClass('theme-status-open');
				$self.setNavigationStatus();
			}});		
		};
		
		/**********************************************************************/
		
		this.getNavigationHeight=function(object)
		{
			var height=object[0].actual('outerHeight',{'includeMargin':true});
			return(height);
		};
		
		/**********************************************************************/
		
		this.setNavigationHeight=function(object)
		{
			var height=$self.getNavigationHeight(object);
			$navigation.height(height);
			$header.parent('.theme-header-parent').height(height);
		};
		
		/**********************************************************************/
		
		this.openNavigation=function(object)
		{
			object[0].css({opacity:1}).addClass('theme-status-open');
			object[1].css({opacity:0}).removeClass('theme-status-open');

			var height=$self.getNavigationHeight(object);
			
			$navigation.animate({height:height},{duration:parseInt(themeOption.header.navigation_bar_open_event_duration),easing:themeOption.header.navigation_bar_open_event_easing,complete:function()
			{
				$navigation.removeClass('theme-status-processing').addClass('theme-status-open');
				$self.setNavigationStatus();
			}});			
		};
		
		/**********************************************************************/
		
		this.isObjectOpen=function(object)
		{
			return(object.hasClass('theme-status-open') ? true : false);
		};
		
		/**********************************************************************/
		
		this.openObject=function(object)
		{
			object[0].animate({opacity:1},{duration:parseInt(themeOption.header.navigation_bar_fade_event_duration),easing:themeOption.header.navigation_bar_fade_event_easing,complete:function()
			{
				object[0].addClass('theme-status-open');
				object[1].removeClass('theme-status-open');
				$navigation.removeClass('theme-status-processing');
				$self.setNavigationStatus();
			}});			
		};
		
		/**********************************************************************/
		
		this.closeObject=function(object)
		{
			object[1].animate({opacity:0},{duration:parseInt(themeOption.header.navigation_bar_fade_event_duration),easing:themeOption.header.navigation_bar_fade_event_easing,complete:function()
			{
				object[1].removeClass('theme-status-open');
				$self.setNavigationStatus();
			}});				
		};

		/**********************************************************************/

		this.setHeaderResponsive=function()
		{
			var width=$header.parent().actual('width');
			
			if(width<$themeOption.header.responsive_mode)
			{
				try
				{
					$menuResponsiveObject.open();
				}
				catch(e) {}
				
				$header.removeClass('theme-header-sticky');
				$header.addClass('theme-mode-responsive');
				$header.parents('.theme-header-parent').css('height','auto');
			}
			else
			{
				$header.removeClass('theme-mode-responsive');
				$header.parents('.theme-header-parent').css('height',$header.actual('height'));
			}
			
			try
			{
				$menuResponsiveObject.resize();
			}
			catch(e) {}
			
			if(($self.isNavigationOpen()) && (!$self.isNavigationProcessing()))
			{
				var object=[$searchBar,$menuBar];
				if($self.isObjectOpen($menuBar)) object=[$menuBar,$searchBar];
				$self.setNavigationHeight(object);
			}
		};
		
		/**********************************************************************/
	};
	
	/**************************************************************************/
	
	$.fn.header=function(themeOption) 
	{
		var header=new Header(this,themeOption);
		header.build();
	};
	
	/**************************************************************************/

})(jQuery,document,window);

/******************************************************************************/
/******************************************************************************/