"use strict";
/******************************************************************************/
/******************************************************************************/

jQuery(document).ready(function($) 
{	
	/**************************************************************************/
	
	var clickEventType=((document.ontouchstart!==null) ? 'click' : 'touchstart');
	
	/**************************************************************************/

	try
	{
		$.fn.qtip.zindex=10;
	}
	catch(e) {}
	
	/**************************************************************************/
	
	$('a.theme-window-target-blank').attr('target','_blank');
	
	/**************************************************************************/
	
	$('.theme-infield-label').inFieldLabels();

	/**************************************************************************/

	$('.theme-set-post-like-count').bind(clickEventType,function(e) 
	{
		e.preventDefault();
		
		try
		{
			var $self=$(this);

			var helper=new PBHelper();

			var data={};

			if($self.parent('.theme-circle-top').hasClass('theme-status-disabled')) return;

			data.action='set_post_like_count';
			data.post_id=helper.getValueFromClass($self,'theme-value-post-id-');

			jQuery.ajax(
			{
				url				:	themeOption.config.ajax_url,
				data			:	data,
				type			:	'GET',
				success			:	function(response)
				{
					if(String(typeof(response.like_count))==='undefined') return;

					if(response.like_count<=0) return;

					$self.attr('title',response.title);

					$self.parent().next('.theme-circle-bottom').html(response.like_count);

					$self.parent().addClass('theme-status-selected').addClass('theme-status-disabled');
				},
				dataType		:	'json'
			});
		}
		catch(e) {}
	});
	
	/**************************************************************************/
	
	$('.theme-set-post-share').bind(clickEventType,function(e) 
	{
		e.preventDefault();	
		
		var $self=$(this);
		var section=$('#theme-post-share');
		
		if(section.hasClass('theme-status-open'))
		{
			$self.parent('span').removeClass('theme-status-selected');
			section.css('height',0).removeClass('theme-status-open').addClass('theme-status-close');
			return;
		}
		
		$self.parent('span').addClass('theme-status-selected');
		
		var height=parseInt(section.children('span').actual('outerHeight',{'includeMargin':true}));
		section.animate({'height':height},{'duration':300,complete:function()
		{
			section.removeClass('theme-status-close').addClass('theme-status-open');
		}});
	});
	
	$(document).click(function(event) 
	{ 
		if($(event.target).hasClass('theme-set-post-share')) return;
		$('#theme-post-share').css('height',0).removeClass('theme-status-open').addClass('theme-status-close');
		$('#theme-post-share').prevAll('span').removeClass('theme-status-selected');
	});
	
	/**************************************************************************/
	
	$('.widget_search label').inFieldLabels();
	
	/**************************************************************************/
	
	$('.widget_archive>ul>li').each(function() 
	{
		var text=$(this).text();
		var link=$(this).children('a').html(text).clone(true,true);
		$(this).html(link);
	});
	
	$('.widget_archive').css('display','block');

	/**************************************************************************/

	$('.widget_categories>ul>li').each(function() 
	{
		var link=$(this).children('a').text($(this).text());
		$(this).html(link).css('display','block');
	});
	
	/**************************************************************************/
	
	$('.widget_recent_comments>ul>li').each(function() 
	{
		var link=$(this).children('a').text($(this).text());
		$(this).html(link).css('display','block');
	});
	
	/**************************************************************************/
	
	$('.widget_rss>ul>li').each(function() 
	{
		var author=$(this).children('cite').clone(true,true);
		var date=$(this).children('.rss-date').clone(true,true);
				
		$(this).children('cite').remove();
		$(this).children('.rss-date').remove();
		
		if(date.length===1) $(this).children('a').after(date);
		if(author.length===1) $(this).children('a').after(author);
		
		$(this).css({display:'block'});
	});
	
	/**************************************************************************/

	$('.widget_nav_menu a').bind(clickEventType,function(e) 
	{
		if($(this).attr('href').substr(0,1)==='#')
		{			
			e.preventDefault();
			
			var menu=$(this).parents('.widget_nav_menu');
					
			menu.find('li').removeClass('current-menu-item current-menu-ancestor current_page_item');
			menu.find('ul>li>ul').css('display','none');
			
			$(this).parents('ul.sub-menu').css('display','block');
			$(this).parents('li').addClass('current-menu-item');
			
			$(this).next('ul.sub-menu').css('display','block');
		}
		else window.location.href=$(this).attr('href');
		
		return(true);
	});
	
	$('.widget_nav_menu a').hover(function() { $(this).append('<span>'); },function() { $(this).children('span').remove() } );
	
	$('.widget_nav_menu').each(function() 
	{
		$(this).find('li.current-menu-item,li.current_page_item').parents('ul.sub-menu').css('display','block');
	});
	
	/**************************************************************************/
	
	$('.widget_archive>select,.widget_categories>select').dropkick();
	
	$('.widget_archive .dk_options_inner,.widget_categories .dk_options_inner').each(function() 
	{
		$(this).find('a[data-dk-dropdown-value="-1"],a[data-dk-dropdown-value=""]').parent('li').remove();
	});
	
	/**************************************************************************/
	
	$('.widget_search #searchform>div').each(function() 
	{
		$(this).find('label').addClass('theme-infield-label');
		$(this).find('input[type="submit"]').remove();
		
		var button=$('<button type="submit"><i class="fa fa-search"></i></button>');
		
		$(this).append(button);
	});
	
	$('.widget_search').css('display','block');
	
	/**************************************************************************/
	
	var body=$('body');
	var footer=$('.theme-footer');
	var content=$('.theme-content');
	
	if(body.hasClass('theme-footer-sticky'))
	{
		$(window).windowDimensionListener({change:function(width,height)
		{	
			var menuHeight=$('.theme-header.theme-header-sticky').actual('height');
		
			var footerHeight=footer.actual('outerHeight');
			var windowHeight=$(window).actual('height')-menuHeight;

			if(windowHeight>footerHeight)
			{
				body.addClass('theme-footer-sticky');
				content.css({'margin-bottom':footerHeight});			
			}
			else
			{
				body.removeClass('theme-footer-sticky');
				content.css({'margin-bottom':'0'});	
			}
			
			footer.css({'visibility':'visible'});
		}});
	}
	else footer.css({'visibility':'visible'});
	
	/**************************************************************************/
	
	$('.theme-scroll-to-comment').bind(clickEventType,function(e)
	{
		if($('#comments').length!==1) return;
		
		e.preventDefault();
		$.scrollTo($('#comments'),{duration:300});
	});
	
	/**************************************************************************/
	
	$('#comments').on(clickEventType,'.theme-comment-content-read-more-link',function(e)
	{
		e.preventDefault();
		var parent=$(this).parent('p');
		
		parent.children('.theme-comment-content-excerpt,.theme-comment-content-read-more-link').css('display','none');
		parent.children('.theme-comment-content-content,.theme-comment-content-read-less-link').css('display','inline');
	});
	
	$('#comments').on(clickEventType,'.theme-comment-content-read-less-link',function(e)
	{
		e.preventDefault();
		var parent=$(this).parent('p');
		
		parent.children('.theme-comment-content-excerpt,.theme-comment-content-read-more-link').css('display','inline');
		parent.children('.theme-comment-content-content,.theme-comment-content-read-less-link').css('display','none');
	});
   
	/**************************************************************************/
	
	if(parseInt(themeOption.goToPageTop.enable)===1)
	{
		$('body').waypoint(function(direction)
		{
			if(direction==='down')
				$('#theme-go-to-top').animate({opacity:1},{duration:1000});
			else $('#theme-go-to-top').animate({opacity:0},{duration:250});
		},
		{
			offset	:	'0%'
		});
		
		$(window).bind('hashchange',function(e) 
		{
			e.preventDefault();
			
			var hash=window.location.hash.substring(1);
			if($.trim(hash)===$.trim(themeOption.goToPageTop.hash))
			{
				var options={};
				
				if(parseInt(themeOption.goToPageTop.animation_enable)===1)
					options={duration:parseInt(themeOption.goToPageTop.animation_duration),easing:themeOption.goToPageTop.animation_easing};
				
				options.onAfter=function() { window.location.hash='#'; };
				
				$.scrollTo(0,options);
			}
		});
	};

	/**************************************************************************/
	
	$('.theme-layout-100').responsiveElement({className:'theme-responsive-column-a'});
	$('.theme-layout-50x50').responsiveElement({className:'theme-responsive-column-a'});
	$('.theme-layout-33x33x33').responsiveElement({width:650,className:'theme-responsive-column-a'});
	$('.theme-layout-25x25x25x25').responsiveElement({width:650,className:'theme-responsive-column-a'});
	$('.theme-layout-66x33').responsiveElement({className:'theme-responsive-column-a'});
	$('.theme-layout-33x66').responsiveElement({className:'theme-responsive-column-a'});
	$('.theme-layout-25x75').responsiveElement({className:'theme-responsive-column-a'});
	$('.theme-layout-75x25').responsiveElement({className:'theme-responsive-column-a'});
	
	/**************************************************************************/
});

/******************************************************************************/
/******************************************************************************/