<?php
		global $post,$norgeParentPost,$more;
		
		the_post();
		
		$Theme=new Theme();
		
		$Blog=new ThemeBlog();
		$Page=new ThemePage();
		$Post=new ThemePost();
		$Validation=new ThemeValidation();
		$WidgetArea=new ThemeWidgetArea();
		
		$Post->setPostViewCount();
		
		$option=ThemeOption::getPostMeta($post);
		
		$widgetAreaData=$WidgetArea->getWidgetAreaByPost($norgeParentPost->post,true,true);

		$enable=array();
		$enableIndex=array('post_date_visible','post_tag_visible','post_category_visible','post_author_name_visible','post_author_info_visible','post_like_count_visible','post_view_count_visible','post_comment_count_visible','post_navigation_visible','post_share_button_visible','post_post_related_visible');
		foreach($enableIndex as $value) 
			$enable[$value]=ThemeOption::getGlobalOption($post,$value);
		$enable['post_comment_count_visible']=$enable['post_comment_count_visible'] && comments_open(get_the_id());
		
		$postSidebar=$enable['post_view_count_visible'] || $enable['post_comment_count_visible'] || $enable['post_like_count_visible'] || $enable['post_share_button_visible'];
		
		$postClass=array('theme-post','theme-clear-fix');
		if($postSidebar) array_push($postClass,'theme-post-sidebar-enable');			
?>
		<div class="theme-post-single">

			<div <?php post_class(join(' ',$postClass)); ?> id="post-<?php the_ID(); ?>">
<?php
		/**********************************************************************/

		$html=$Post->createFeatureElement($post,$option,$widgetAreaData);
		
		if($Validation->isNotEmpty($html)) echo $html;
		
		/**********************************************************************/

		if($postSidebar)
		{
?>
				<div class="theme-post-sidebar">
<?php
			if($enable['post_share_button_visible']==1)
				echo $Post->createPostShareCircle($post);
			
			if($enable['post_view_count_visible']==1)
				echo $Post->createPostViewCountCircle($post);
			
			if($enable['post_comment_count_visible']==1)
				echo $Post->createPostCommentCountCircle($post);
			
			if($enable['post_like_count_visible']==1)
				echo $Post->createPostLikeCountCircle($post);
?>
				</div>
<?php
		}
		
		/**********************************************************************/
?>
				<div class="theme-post-content theme-clear-fix"><?php echo apply_filters('the_content',do_shortcode(get_the_content())); ?></div>
				<div class="theme-pagination theme-clear-fix">
<?php 
		wp_link_pages(array
		(
			'before'				=>	'',
			'after'					=>	'',
			'next_or_number'		=>	'number',		
			'previouspagelink'		=>	__('Previous',THEME_DOMAIN),
			'nextpagelink'			=>	__('Next',THEME_DOMAIN),
			'link_before'			=> '<span>',
			'link_after'			=> '</span>'
		)); 
?>
				</div>
<?php

		/**********************************************************************/

		if($enable['post_tag_visible']==1) 
		{
			$tag=$Post->createTagList();
			if($Validation->isNotEmpty($tag))
				echo '<div class="theme-post-meta-bottom theme-clear-fix">'.sprintf(esc_html__('Tags: %s',THEME_DOMAIN),$tag).'</div>';	
		}
		
		/**********************************************************************/
?>	
				<div class="theme-post-divider theme-clear-fix"></div>
<?php
		/**********************************************************************/

		if($enable['post_author_info_visible']==1)
		{
			$authorData=array
			(
				'name'			=>	get_the_author_meta('display_name'),
				'avatar'		=>	get_avatar(get_the_author_meta('ID'),80,'',get_the_author_meta('display_name')),
				'description'	=>	get_the_author_meta('user_description')
			);
			
			$authorMeta=array
			(
				'twitter'		=>	array('url'=>null,'icon'=>'twitter'),
				'facebook'		=>	array('url'=>null,'icon'=>'facebook'),
				'googleplus'	=>	array('url'=>null,'icon'=>'google-plus')
			);
			
			foreach($authorMeta as $authorMetaIndex=>$authorMetaData)
			{
				$authorMetaData['url']=get_the_author_meta($authorMetaIndex);
				if($Validation->isNotEmpty($authorMetaData['url']))
					$authorMeta[$authorMetaIndex]['url']=get_the_author_meta($authorMetaIndex);
				else unset($authorMeta[$authorMetaIndex]);
			}
?>
				<div class="theme-post-author-info theme-clear-fix">
<?php
			if($Validation->isNotEmpty($authorData['avatar']))
			{
?>	
					<div class="theme-post-author-info-avatar">
						<?php echo $authorData['avatar']; ?>
					</div>
<?php
			}
?>
					<div class="theme-post-author-info-content">
						<h6><a href="<?php echo esc_url(get_author_posts_url($post->post_author)); ?>" title="<?php echo sprintf(esc_attr('View all posts from "%s".',THEME_DOMAIN),get_the_author()); ?>"><?php esc_html_e($authorData['name']); ?></a></h6>
<?php
			if($Validation->isNotEmpty($authorData['description']))
			{
?>
						<p><?php echo $authorData['description']; ?></p>
<?php
			}
?>				
					</div>
<?php
			if(count($authorMeta))
			{
?>
					<div class="theme-post-author-info-meta">
						<ul class="theme-reset-list theme-clear-fix">
<?php
				foreach($authorMeta as $authorMetaIndex=>$authorMetaData)
				{
?>
							<li>
								<span class="theme-circle theme-circle-size-small">
									<span class="theme-circle-top fa fa-<?php echo esc_attr($authorMetaData['icon']); ?>">
										<a href="<?php echo esc_url($authorMetaData['url']); ?>" class="pb-window-target-blank"></a>
									</span>
								</span>
							</li>
<?php
				}
?>
						</ul>
					</div>
<?php
				
			}
?>
				</div>
<?php			
		}
		
		/**********************************************************************/

		if($enable['post_navigation_visible']==1) 
			echo $Post->createPostNavigation();
		
		/**********************************************************************/
		
		if($enable['post_post_related_visible']==1)
			echo $Post->createPostRelated();
		
		/**********************************************************************/

		get_template_part('comment');
?>
			</div>
			
		</div>